import { computed } from 'vue';
import { createDecorator } from 'vue-class-component';
/**
 * Decorator for provide options
 * @param to to
 */
export function Provide(to) {
    return createDecorator((componentOptions, key) => {
        const originalProvide = componentOptions.provide;
        componentOptions.provide = function () {
            const providedValue = typeof originalProvide === 'function'
                ? originalProvide.call(this)
                : originalProvide;
            return Object.assign(Object.assign({}, providedValue), { [to || key]: computed(() => this[key]) });
        };
    });
}
